import { cdn, upCdn } from '@/services/api';
import {
  checkData,
} from '@/services/utils';

export const getDownloadList = (meta2dData:any, path:string='v') => {
  const lists = new Set();
  //TODO 加一个type区分是数据/还是接口
  //背景图片
  // const meta2dData = meta2d.data();
  let img = meta2dData.bkImage;
  if (img) {
    if (img.startsWith('/') || img.startsWith(cdn) || img.startsWith(upCdn)) {
      let _img = img.replace(cdn, '').replace(upCdn, '');
      if(_img.startsWith('/v/')){
        _img = _img.slice(2);
      }
      lists.add({
        url:img,
        path:`/view/projects/${path}` +_img,
      })
    }
  }

  //图片图元(image strokeImage backgroundImage)
  const imageKeys = ['image','strokeImage','backgroundImage'];
  const images: string[] = [];
  for (const pen of meta2dData.pens) {
    for (const i of imageKeys) {
      const image = pen[i];
      if (image) {
        if (
          image.startsWith('/') ||
          image.startsWith(cdn) ||
          image.startsWith(upCdn)
        ) {
          // 只考虑相对路径下的 image ，绝对路径图片无需下载
          let _img = image.replace(cdn, '').replace(upCdn, '');
          if(_img.startsWith('/v/')){
            _img = _img.slice(2);
          }
          if (!images.includes(image)) {
            // let _img = image.replace(cdn, '').replace(upCdn, '');
            lists.add({
              url:image,
              path:`/view/projects/${path}`+_img
            });
          }
          pen[i] = `/view/projects/${path}`+_img
        }
      }
    }
  }
  
  //其他文件
  const files = [
    // '/view/assets/index.js',
    '/view/assets/index.css',
    '/view/css/index.css',

    '/view/js/marked.min.js',
    '/view/js/mycharts.js',
    '/view/js/echarts.min.js',
    '/view/js/lcjs.iife.js',
    '/view/js/highcharts.js',
    '/view/js/highcharts-more.js',
    '/view/js/2d-components.js',

    '/view/index.html',
    '/view/favicon.ico',
    '/view/view.conf',
    '/view/离线部署包使用说明.pdf'
  ];
  files.forEach((file)=>{
    lists.add({
      url: (cdn ? cdn:'')+  file,
      path:file
    });
  });

  //数据
  // const data: any = meta2d.data();
  if (meta2dData._id) delete meta2dData._id;
  if (meta2dData.id) delete meta2dData.id;
  if ((meta2dData as any).image) delete (meta2dData as any).image;
  checkData(meta2dData);
  lists.add({
    data:JSON.stringify(meta2dData).replaceAll(cdn, '').replaceAll(upCdn, ''),
    path:`/view/projects/${path}/data`,
  });

  return lists;
}